#version 430

layout(location = 0) out vec4 fragColor;

in vec3 n; 
in vec3 v;
in vec3 p;
in vec3 color;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

uniform vec3 lightPosition[20];
uniform vec3 direction[20];
uniform uint type[20];
uniform float constant[20];
uniform float linear[20];
uniform float quadratic[20];
uniform vec3 ambientColor[20];
uniform vec3 diffuseColor[20];
uniform vec3 specularColor[20];
uniform int actualLights;


uniform vec3 cameraLocation;

float shininess = 0.5f;

void main(){
			
			vec3 V = normalize(v);
			vec3 N = normalize(n);
			vec3 I = vec3(1.0f,1.0f,1.0f);
			vec3 diffus = vec3(0.0f,0.0f,0.0f);
			vec3 spec = vec3(0.0f,0.0f,0.0f);
			vec3 blinnPhong = vec3(0.0f,0.0f,0.0f);
			vec3 lambert = vec3(0.0f,0.0f,0.0f);
			float cosThetaSpec;
			float cosThetaDiff;
			float cosTheta;
			float specularStrenght = 6.0f;

			vec3 ambient = vec3(0.1f,0.1f,0.1f);
			vec3 vDir = normalize(cameraLocation - p);

			for(int i = 0; i < actualLights; i++){
				
				vec3 lightPos = lightPosition[i];

				vec3 L = normalize(lightPos - p);
				//vec3 H = normalize(L + V);
				vec3 reflection = reflect(-direction[i], N);
				cosThetaSpec = pow(max(dot(vDir, reflection), 0.0), 32);

				spec = cosThetaSpec * specularColor[i] * specularStrenght;

				//spec = spec * max(dot(N, L), 0);

				//Diffuser Teil
				cosThetaDiff = max(dot(L, N), 0.0);
				diffus =  cosThetaDiff * diffuseColor[i] ;
				
		
				
				/*float surfaceLightDistance = distance( lightPos  , p );

				float a = constant[i] + surfaceLightDistance * linear[i] + pow(surfaceLightDistance,2) * quadratic[i];
				
				vec3 ambient = ambientColor[i];
				vec3 diffuse = diffuseColor[i]; 
				vec3 specular = specularColor[i];
				I = ( (1/a) * ambient  +  (1/a) * diffuse + (1/a) * specular ) * 1/3;
				*/
				//vec3 res = (ambient+ diffuse + specular) * color
				blinnPhong = blinnPhong +  ((ambient + diffus + spec) * color );
				
				
				
				/*
				//lambert
				vec3 lightPos = lightPosition[i];
				cosTheta = max(dot(N, normalize(lightPos - p)),0);
				float surfaceLightDistance = distance( lightPos  , p );

				float a = constant[i] + surfaceLightDistance * linear[i] + pow(surfaceLightDistance,2) * quadratic[i];
				
				vec3 ambient = ambientColor[i];
				vec3 diffuse = diffuseColor[i]; 
				vec3 specular = specularColor[i];
				//I = ( (1/a) * ambient  +  (1/a) * diffuse + (1/a) * specular ) * 1/3;
				lambert = lambert + (  ( color * I) * cosTheta );
				*/
			}
			fragColor = vec4(blinnPhong,1.0f);
			//fragColor =vec4(lambert,1.0f);
			/*

			// blinn = Summe von [ (Fr alle Lichtquellen) I *( spec + diffus(= lambert)) ]
        // Ispec = ks * cosTheta
        // cosTheta = Winkelhalbierende = (V + L / ||V + L||)^shininess
        // V = Punkt nach Betrachter normalisiert
        // L = Punkt nach Licht normalisiert
        // ks = Spekulrer Reflexionskoeffizient (0 bis 1)
        V = V.normalize();
        N = N.normalize();
        Vec3 I;
        Vec3 diffus;
        Vec3 spec;
        Vec3 blinnPhong = Vec3.zero;
        float cosThetaSpec;
        float cosThetaDiff;
        for (Light light : lights) {
            Vec3 L = light.calcDirection(P);

            //Spekular Teil
            Vec3 H = Vec3.add(L, V).normalize();
            cosThetaSpec = (float) Math.pow(Math.max(Vec3.dot(N, H), 0), shininess);
            spec = Vec3.mul(specularColor, cosThetaSpec);
            // multiply the specular factor with the dot product of the normalized normal and the normalized light vector.
            spec = Vec3.mul(spec, Math.max(Vec3.dot(N, L), 0));

            //Diffuser Teil
            cosThetaDiff = Math.max(Vec3.dot(L, N), 0);
            diffus = Vec3.mul(diffuseColor, cosThetaDiff);

            I = light.calcIntensity(P);
            blinnPhong = Vec3.add(blinnPhong, Vec3.mul(I, Vec3.add(diffus, spec)));


			float surfaceLightDistance = Vec3.sub(this._position, surfacePosition).length();
        float a = constantAttenuation + surfaceLightDistance * linearAttenuation + (surfaceLightDistance * surfaceLightDistance) * quadraticAttenuation;

        return Vec3.mul(intensity, 1/a);

        }

        return blinnPhong;
			*/

}