// shadertype=glsl
#version 430
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normalsIn;
layout (location = 3) in vec4 colorIn;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat4 normalMatrix;
uniform mat4 lightSpace;



uniform vec3 lightPosition[20];
uniform vec3 direction[20];
uniform float coneAngle[20];
uniform uint type[20];
uniform float constant[20];
uniform float linear[20];
uniform float quadratic[20];
uniform vec3 ambientColor[20];
uniform vec3 diffuseColor[20];
uniform vec3 specularColor[20];
uniform int actualLights;

uniform vec3 cameraLocation;


out vec3 n; 
out vec3 v;
//out vec3 p;
out vec3 color;
out vec3 l[20]; // direction to light
out vec4 fragPosLightSpace;





void main(){
		vec4 p = model * vec4(position,1.0f);
		gl_Position = projection * view * p;
		//n = normalize(mat3(transpose(inverse(model))) * normalsIn);
		n = normalize(mat3(normalMatrix)* normalsIn);
		v = normalize(cameraLocation - p.xyz);
		color = vec3(colorIn);
		fragPosLightSpace = lightSpace * p;
for(int i = 0; i < actualLights; i++){
			l[i] = normalize(lightPosition[i] - p.xyz);
		}

}

/*
							 Vec3 P,
                             Vec3 V,
                             Vec3 N,
                             Vec3 diffuseColor,
                             Vec3 specularColor,
                             float shininess,
                             Light lights[]) {
      
        // blinn = Summe von [ (Fr alle Lichtquellen) I *( spec + diffus(= lambert)) ]
        // Ispec = ks * cosTheta
        // cosTheta = Winkelhalbierende = (V + L / ||V + L||)^shininess
        // V = Punkt nach Betrachter normalisiert
        // L = Punkt nach Licht normalisiert
        // ks = Spekulrer Reflexionskoeffizient (0 bis 1)
        V = V.normalize();
        N = N.normalize();
        Vec3 I;
        Vec3 diffus;
        Vec3 spec;
        Vec3 blinnPhong = Vec3.zero;
        float cosThetaSpec;
        float cosThetaDiff;
        for (Light light : lights) {
            Vec3 L = light.calcDirection(P);

            //Spekular Teil
            Vec3 H = Vec3.add(L, V).normalize();
            cosThetaSpec = (float) Math.pow(Math.max(Vec3.dot(N, H), 0), shininess);
            spec = Vec3.mul(specularColor, cosThetaSpec);
            // multiply the specular factor with the dot product of the normalized normal and the normalized light vector.
            spec = Vec3.mul(spec, Math.max(Vec3.dot(N, L), 0));

            //Diffuser Teil
            cosThetaDiff = Math.max(Vec3.dot(L, N), 0);
            diffus = Vec3.mul(diffuseColor, cosThetaDiff);

            I = light.calcIntensity(P);
            blinnPhong = Vec3.add(blinnPhong, Vec3.mul(I, Vec3.add(diffus, spec)));

        }

        return blinnPhong;

____________________________________________ Vertex
Vec4 outPos = Mat4.mul(_modelViewProjectionMatrix, v.position);
        Vec3 P = new Vec3(Mat4.mul(_modelMatrix, v.position));
        Vec3 N = Mat3.mul(_normalMatrix, v.normal);
        Vec3 V = Vec3.sub(_cameraLocation, P);
        Vec3 C =  v.color;
        //Vec3 blinnColor = IlluminationModels.blinn(P, V, N, diffuseColor, specular, shininess, _lights);

        Varyings varyings = new Varyings(new float[]{N.x, N.y, N.z,
                                                    V.x,V.y,V.z,
                                                    P.x,P.y,P.z,
                                                    C.r(), C.g(), C.b()
        });


        return new Vertex(outPos, varyings);


---------------------------------------------- Fragment 
//Index (0 - 2) -> N
        //Index (3 - 5) -> V
        //Index (6 - 8) -> P
        //Index (9 - 11) -> Color
        float[] values = varyings.getValues();
        Vec3 N = new Vec3(values[0],values[1],values[2]);
        Vec3 V = new Vec3(values[3],values[4],values[5]);
        Vec3 P = new Vec3(values[6],values[7],values[8]);
        Vec3 diffuseColor = Vec3.mul(new Vec3(values[9], values[10], values[11]), diffuse);

        return new Vec4(IlluminationModels.blinn(P, V, N, diffuseColor, specular, shininess, _lights),alpha);

        // Delete me:
        //throw new UnsupportedOperationException("BlinnPhongShader");




		Vec4 outPos = Mat4.mul(_modelViewProjectionMatrix, v.position);
        Vec3 P = new Vec3(Mat4.mul(_modelMatrix, v.position));
        Vec3 N = Mat3.mul(_normalMatrix, v.normal);
        Vec3 V = Vec3.sub(_cameraLocation, P);
*/