#version 430

layout(location = 0) out vec4 fragColor;


in vec2 texCoords;
in vec3 n; 
in vec3 v;
in vec3 p;


uniform sampler2D myTexture;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

uniform vec3 lightPosition[20];
uniform vec3 direction[20];
uniform uint type[20];
uniform float constant[20];
uniform float linear[20];
uniform float quadratic[20];
uniform vec3 ambientColor[20];
uniform vec3 diffuseColor[20];
uniform vec3 specularColor[20];
uniform int actualLights;


uniform vec3 cameraLocation;

float shininess = 0.5f;


/*
void main(){
			vec4 texCol = texture(myTexture, texCoords);
			fragColor = vec4(texCol.r , texCol.gba);

}
*/
void main(){
			vec4 texCol = texture(myTexture, texCoords);
			float alpha = texCol.a;
			vec3 V = normalize(v);
			vec3 N = normalize(n);
			vec3 I = vec3(1.0f,1.0f,1.0f);
			vec3 diffus = vec3(0.0f,0.0f,0.0f);
			vec3 spec = vec3(0.0f,0.0f,0.0f);
			vec3 blinnPhong = vec3(0.0f,0.0f,0.0f);
			vec3 lambert = vec3(0.0f,0.0f,0.0f);
			float cosThetaSpec;
			float cosThetaDiff;
			float cosTheta;
			float specularStrenght = 1.8f;

			vec3 ambient = vec3(0.1f,0.1f,0.1f);

			for(int i = 0; i < actualLights; i++){
				
				vec3 lightPos = lightPosition[i];

				vec3 L = normalize(lightPos - p);
				//vec3 H = normalize(L + V);
				vec3 reflection = reflect(-direction[i], N);
				cosThetaSpec = pow(max(dot(N, reflection), 0.0), 32);

				//Spec Teil
				spec = cosThetaSpec * specularColor[i] * specularStrenght;

				//Diffuser Teil
				cosThetaDiff = max(dot(L, N), 0.0);
				diffus = cosThetaDiff * diffuseColor[i] ;
				blinnPhong = blinnPhong +  ((ambient + diffus + spec) * texCol.rgb);
				
			}
			fragColor = vec4(blinnPhong,alpha);

		}
		