// shadertype=glsl
#version 430

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normalsIn;
layout (location = 2) in vec2 texCoord;
layout (location = 4) in vec3 tangent;


uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat4 normalMatrix;
uniform mat4 lightSpace;



uniform vec3 lightPosition[20];
uniform vec3 direction[20];
uniform float coneAngle[20];
uniform uint type[20];
uniform float constant[20];
uniform float linear[20];
uniform float quadratic[20];
uniform vec3 ambientColor[20];
uniform vec3 diffuseColor[20];
uniform vec3 specularColor[20];
uniform int actualLights;

uniform vec3 cameraLocation;


out vec3 n; //Normal
out vec3 v; //direction to camera
out vec2 texCoords;
out vec3 l[20]; // direction to light
//out vec3 lDir[20];
out vec4 fragPosLightSpace;
out mat3 TBN;

void main(){
		vec4 p = model * vec4(position,1.0f);
		gl_Position = projection * view * p;
		//n = normalize(mat3(transpose(inverse(model))) * normalsIn);
		n = normalize(mat3(normalMatrix)* normalsIn);
		v = normalize(cameraLocation - p.xyz);
		fragPosLightSpace = lightSpace * p;
		//TBN Matrix berechnen
		vec3 T = normalize(vec3(model * vec4(normalize(tangent),   0.0)));
		vec3 B = cross(T, n);
		TBN = mat3(T, B, n);
		for(int i = 0; i < actualLights; i++){
			l[i] = normalize(lightPosition[i] - p.xyz);
			//lDir[i] = normalize(lightPosition[i] - direction[i]);
		}
		texCoords = texCoord;
}